import _Object$assign from 'babel-runtime/core-js/object/assign';
import _regeneratorRuntime from 'babel-runtime/regenerator';

var _marked = [keaSaga].map(_regeneratorRuntime.mark);

import { call, take, cancel, fork } from 'redux-saga/effects';
import { eventChannel } from 'redux-saga';
import { getCache, setCache } from 'kea';

var emitter = void 0;
var forkedSagas = {};

function createComponentChannel(socket) {
  return eventChannel(function (emit) {
    emitter = emit;
    return function () {};
  });
}

export function keaSaga() {
  var channel, _ref, _startSaga, _cancelSaga, saga, path;

  return _regeneratorRuntime.wrap(function keaSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return call(createComponentChannel);

        case 2:
          channel = _context.sent;

        case 3:
          if (!true) {
            _context.next = 20;
            break;
          }

          _context.next = 6;
          return take(channel);

        case 6:
          _ref = _context.sent;
          _startSaga = _ref.startSaga;
          _cancelSaga = _ref.cancelSaga;
          saga = _ref.saga;
          path = _ref.path;

          if (!_startSaga) {
            _context.next = 15;
            break;
          }

          _context.next = 14;
          return fork(saga);

        case 14:
          forkedSagas[path] = _context.sent;

        case 15:
          if (!_cancelSaga) {
            _context.next = 18;
            break;
          }

          _context.next = 18;
          return cancel(forkedSagas[path]);

        case 18:
          _context.next = 3;
          break;

        case 20:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this);
}

export function startSaga(path, saga) {
  if (!emitter) {
    return false;
  }

  var count = getCount(path);

  if (count === 0) {
    emitter({ startSaga: true, saga: saga, path: path });
  }

  setCount(path, count + 1);

  return true;
}

export function cancelSaga(path) {
  if (!emitter) {
    return false;
  }

  var count = getCount(path);
  setCount(path, count - 1);

  if (count <= 1) {
    emitter({ cancelSaga: true, path: path });
  }

  return true;
}

function getCount(path) {
  var sagaCounter = getCache('sagaCounter') || {};
  return sagaCounter[path] || 0;
}

function setCount(path, count) {
  var _Object$assign2;

  var sagaCounter = getCache('sagaCounter') || {};
  setCache('sagaCounter', _Object$assign({}, sagaCounter, (_Object$assign2 = {}, _Object$assign2[path] = count, _Object$assign2)));
}