'use strict';

exports.__esModule = true;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

exports.keaSaga = keaSaga;
exports.startSaga = startSaga;
exports.cancelSaga = cancelSaga;

var _effects = require('redux-saga/effects');

var _reduxSaga = require('redux-saga');

var _kea = require('kea');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = [keaSaga].map(_regenerator2.default.mark);

var emitter = void 0;
var forkedSagas = {};

function createComponentChannel(socket) {
  return (0, _reduxSaga.eventChannel)(function (emit) {
    emitter = emit;
    return function () {};
  });
}

function keaSaga() {
  var channel, _ref, _startSaga, _cancelSaga, saga, path;

  return _regenerator2.default.wrap(function keaSaga$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _context.next = 2;
          return (0, _effects.call)(createComponentChannel);

        case 2:
          channel = _context.sent;

        case 3:
          if (!true) {
            _context.next = 20;
            break;
          }

          _context.next = 6;
          return (0, _effects.take)(channel);

        case 6:
          _ref = _context.sent;
          _startSaga = _ref.startSaga;
          _cancelSaga = _ref.cancelSaga;
          saga = _ref.saga;
          path = _ref.path;

          if (!_startSaga) {
            _context.next = 15;
            break;
          }

          _context.next = 14;
          return (0, _effects.fork)(saga);

        case 14:
          forkedSagas[path] = _context.sent;

        case 15:
          if (!_cancelSaga) {
            _context.next = 18;
            break;
          }

          _context.next = 18;
          return (0, _effects.cancel)(forkedSagas[path]);

        case 18:
          _context.next = 3;
          break;

        case 20:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this);
}

function startSaga(path, saga) {
  if (!emitter) {
    return false;
  }

  var count = getCount(path);

  if (count === 0) {
    emitter({ startSaga: true, saga: saga, path: path });
  }

  setCount(path, count + 1);

  return true;
}

function cancelSaga(path) {
  if (!emitter) {
    return false;
  }

  var count = getCount(path);
  setCount(path, count - 1);

  if (count <= 1) {
    emitter({ cancelSaga: true, path: path });
  }

  return true;
}

function getCount(path) {
  var sagaCounter = (0, _kea.getCache)('sagaCounter') || {};
  return sagaCounter[path] || 0;
}

function setCount(path, count) {
  var _Object$assign2;

  var sagaCounter = (0, _kea.getCache)('sagaCounter') || {};
  (0, _kea.setCache)('sagaCounter', (0, _assign2.default)({}, sagaCounter, (_Object$assign2 = {}, _Object$assign2[path] = count, _Object$assign2)));
}